<?php

@set_time_limit(0);

function CheckAbilityOfInstallation()
{
  $result['Success'] = 1;
  $result['ErrorMessage'] = '!';

  // check if all files are writeable
  $files = file($GLOBALS['TMP_FOLDER']."files.txt");
  foreach ($files as $file)
  {
     $file = $GLOBALS['DOCUMENT_ROOT'].rtrim($file);
     if (file_exists($file))
     {
        if (!is_writable($file) && !@chmod($file, 0777)) // file is not writable
        {
           $result['ErrorMessage'] = "<b>         netcat.</b><br><small>($file   )</small>";
           $result['Success'] = 0;
        }
     }
     else // check dir
     {
        $dirname = dirname($file);
        // find the nearest existing parent directory
        while (!file_exists($dirname))
        {
           $dirname = preg_replace("!/[^/]+$!", "", $dirname);
           if ($dirname=="$GLOBALS[DOCUMENT_ROOT]/netcat") break;
        }

        if (!is_writable($dirname) && !@chmod($dirname, 0777)) // directory is not writable
        {
           $result['ErrorMessage'] = "<b>      $GLOBALS[DOCUMENT_ROOT]/netcat   .</b><br><small>($dirname   )</small>";
           $result['Success'] = 0;
        }
     }
  }

  return $result;
}

function InstallPatch() {

  global $TMP_FOLDER, $MODULE_FOLDER, $ROOT_FOLDER, $db;

  $result['Success'] = 1;
  $result['ErrorMessage'] = '!';

  // update modules
  $installed_modules = $db->get_results("SELECT Keyword FROM Module WHERE Keyword IN ('auth','forum','linkmanager','netshop','search','stats')", ARRAY_A);
  foreach ((array)$installed_modules as $module) {

    // Execute SQL, if any
    if (file_exists($TMP_FOLDER."modules/$module[Keyword].sql")) {
       ExecSQL($TMP_FOLDER."modules/$module[Keyword].sql");
    }

    // Copy all files to modules folder
    nc_installer_copy_all($TMP_FOLDER."modules/$module[Keyword]", $MODULE_FOLDER.$module["Keyword"]);

    // include script if necessary
    if (file_exists($TMP_FOLDER."modules/$module[Keyword].inc.php")) {
      include($TMP_FOLDER."modules/$module[Keyword].inc.php");
    }

    // Remove old files
    if (file_exists($TMP_FOLDER."modules/$module[Keyword].remove")) {

      $files_to_remove = file($TMP_FOLDER."modules/$module[Keyword].remove");

      foreach ($files_to_remove as $file) {
        $file = trim($file,"\r\n/");
        if (is_dir($ROOT_FOLDER.$file)) { @rmdir($ROOT_FOLDER.$file); }
                                   else { @unlink($ROOT_FOLDER.$file); }

      }
    }
  }

  return $result;
}


function nc_installer_copy_all($from, $to) {

    $dh = @opendir($from);

    while (false !== ($file = readdir($dh))) {
      if ($file=="." || $file=="..") continue;
      if (is_dir("$from/$file")) {
        @mkdir("$to/$file", 0755);
        nc_installer_copy_all("$from/$file", "$to/$file");
      }
      else {
        copy("$from/$file", "$to/$file");
      }
    }

    closedir($dh);
}

?>