<?php
/* $Id: function.inc.php,v 1.9 2006/10/26 13:19:33 n Exp $ */

#  
function cuttext($text, $numchar)
{
	$text=strip_tags($text);
	$text=htmlspecialchars($text);
	
	if (strlen($text)>$numchar)
	{
		$tmptext = strpos($text." "," ",$numchar);
		if ($tmptext != 0)
			$text=substr($text,0,$tmptext)."...";
	}
	return $text;
}


function istrpos($haystack,$needle,$offset = 0)
{
	setlocale (LC_ALL, array ('ru_RU.CP1251', 'rus_RUS.1251','russian'));
	return(strpos(strtolower($haystack),strtolower($needle),$offset));
}


function strpos_array($haystack, $needle)
{
  $kill = $offset = $i = 0;

  while ($kill === 0)
  {
    $i++;
    $result = strpos($haystack, $needle, $offset);

    if ($result === FALSE)
    {
      $kill = 1;
    }
    else
    {
      $array[$i] = $result;
      $offset = $result + 1;
    }
  }

  return $array;
}

function NC_CutWord($text, $first_or_last)
{
  $result = NULL;

  $tmp = explode(" ", $text);
  for ($i=0; $i<count($tmp); $i++)
  {
    if ($i == 0 && $first_or_last == 'first')
      continue;
    if ($i == (count($tmp) - 1) && $first_or_last == 'last')
      continue;
    $result .= $tmp[$i]." ";
  }

  return $result;
}

//      
function SearchTextEcho($text, $word)
{
  $mytext = "";
	$text = str_replace("&amp;", "&", $text);

	if ($word)
	{
		$tmptext = istrpos($text,$word);
		$word = substr($text,$tmptext,strlen($word));
		
		if ($tmptext !== FALSE)
		{
		  if ($tmptext >= 70)
		  {
		    $mytext = NC_CutWord(substr($text,$tmptext-70,70), 'first');
			  $mytext2 = NC_CutWord(substr($text,$tmptext+strlen($word),strlen($word)+70), 'last');
			  return "&#133; ".$mytext." <font style='background-color:#fbe99f;'>".$word."</font>".$mytext2." &#133;";
		  }
		  elseif ($tmptext < 70)
		  {
		    $mytext = substr($text,0,$tmptext);
			  $mytext2 = NC_CutWord(substr($text,$tmptext+strlen($word),strlen($word)+70), 'last');
			  return $mytext." <font style='background-color:#fbe99f;'>".$word."</font>".$mytext2." &#133;";
		  }
		}
	}

	return $mytext;
}


function FilterText ($text,$direction=1) 
{
	if ($direction==1)
	{
		$text=addslashes($text);
		$text=str_replace('$',"\\\\\\$",$text);
	}
	else
	{
		$text=stripslashes($text);
		$text=str_replace('\$',"$",$text);
	}

	return $text;
}



function nc_search_highlight_words($document, $search_string, $text_size = 150, $hl_prefix = "<span style='background-color: #fbe99f;'>", $hl_suffix = "</span>") {

   $tokens = preg_split('/\s+/', $search_string);
   
   $first_found_position = false;
   $text_is_cut = false;
   
   //      (     BOOLEAN )
   foreach ($tokens as $token) {
      
      //  
      $clean_token = str_replace(array('"', '*', '+', '>', '<', '-'), '', $token);
      if ( strlen(trim($clean_token)) == 0 ) {
         continue;
      }
      
      //    : chr(1).$clean_token.chr(2)
      $new_document = preg_replace('/([\s"\'!#$%&()*+,.-\/:;<=>?@\[\]{|}])('.preg_quote($clean_token).'[^"\'\s0-9!#$%&()*+,.-\/:;<=>?@\[\]{|}]*)/i', '\1'.chr(1).'\2'.chr(2), ' '.$document);
      
      //  -  
      if ( $new_document != $document ) {
         
         //   ...
         $first_found_position = strpos($new_document, chr(1));
         
         // ...   ,      ...
         if ( !$text_is_cut && $first_found_position !== false ) {
            // ...      ...
            $begin_offset = $first_found_position - floor($text_size / 2);
            if ($begin_offset < 0) {
               $begin_offset = 0;
            }
            $text_cut_length = $text_size + strlen($clean_token) + 2;
            //  2?     .  .  .
            //    ,  -      1
            // ...  
            $document = ( $begin_offset > 0 ? '... ' : '' ) . substr($new_document, $begin_offset, $text_cut_length) . ( $begin_offset + $text_cut_length < strlen($new_document) ? ' ...' : '');
            $text_is_cut = true;
         }
         else {
            $document = $new_document;
         }
      }
   
   }
   
   //       ...
   if ( !$text_is_cut ) {
      // ...     
      $document = substr($document, 0, $text_size) . ($text_size < strlen($document) ? ' ...' : '');
   }
   //     ...
   $document = preg_replace('/^\.\.\. [^\s]*\s+/U', '...', $document);
   // ...    
   $document = preg_replace('/\s+[^\s]* \.\.\.$/U', '...', $document);
   
   //          ...
   if ( strrpos($document, chr(1)) > strrpos($document, chr(2)) ) {
      // ...   
      $document .= chr(2);
   }
   
   //     
   $document = str_replace(chr(1), $hl_prefix, $document);
   $document = str_replace(chr(2), $hl_suffix, $document);
   
   return $document;
}



/**
 *  ,     MATCH(...) AGAINST(...)  BOOLEAN .
 * 
 * @param string $search_string
 * @param string $language
 * @return string
 */
function nc_search_get_db_expression($search_string, $language = "ru") {
   
   global $MODULE_FOLDER;
   $search_module_path = $MODULE_FOLDER . 'search/';
   
   //     -?
   if ( !$search_string ) {
      return "";
   }
   
   //          ?
   if ( !file_exists($search_module_path . 'stemming.' . $language . '.php') ) {
      return $search_string;
   }
   
   //           ?
   include_once($search_module_path . 'stemming.'.$language.'.php');
   $stem_function = 'nc_search_stem_word_'.$language;
   if ( !function_exists($stem_function) ) {
      return $search_string;
   }
   
   $tokens = preg_split('/\s+/', $search_string);
   
   $result = "";
   $have_quote = false;
   foreach ($tokens as $token) {
      if ( $token{0} == '"' ) {
         $have_quote = true;
      }
      if ( strlen($token) == 0 || $have_quote || preg_match('/[0-9!#$%&()*+,.-\/:;<=>?@\[\]{|}]+$/', $token) || $token{strlen($token)-1} == '"' ) {
         $result .= $token . ' ';
      }
      else {
         $result .= $stem_function($token) . '* ';
      }
      if ( $token{strlen($token)-1} == '"') {
         $have_quote = false;
      }
   }
   
   return $result;
}

?>