<?php
/* $Id: function.inc.php,v 1.7 2006/10/23 11:47:08 kx Exp $ */

function Stats_Log()
{
    // nothing to do if module is disabled
    if (!$GLOBALS['MODULE_VARS']['stats']['INSTALLED']) { return; }

    // don't log in admin mode
    if ($GLOBALS["admin_mode"]) { return; }

    // don't log 404s
    global $db, $e404_sub, $catalogue, $sub, $cc, $message, $action;
    if ($sub==$e404_sub) { return; }

    // don't log access from the server's IP (netcat search crawler)
    if ($_SERVER["SERVER_ADDR"]==$_SERVER["REMOTE_ADDR"]) { return; }

    // don't log bot requests
    if (nc_stat_detect_bot($_SERVER["HTTP_USER_AGENT"])) { return; }

    // ----------------

    $CookieID = $_COOKIE['CookieID'];

    if (!$CookieID)
    {
        $CookieID = md5(uniqid(rand(),true));
        setcookie("CookieID",$CookieID,time()+3600*24*365,"/",$HTTP_HOST);
    }

//* not used anyway    $REMOTE_HOST = gethostbyaddr($REMOTE_ADDR);
    $country = Stats_IP2Country($_SERVER["REMOTE_ADDR"]);

    $db->query("INSERT DELAYED INTO Stats_Log
                SET Created = NOW(),
                    User_ID = '$GLOBALS[AUTH_USER_ID]',
                    REMOTE_ADDR = '".mysql_escape_string($_SERVER["REMOTE_ADDR"])."',
                    REMOTE_HOST = '',
                    REMOTE_PORT = '".mysql_escape_string($_SERVER["REMOTE_PORT"])."',
                    HTTP_REFERER = '".mysql_escape_string($_SERVER["HTTP_REFERER"])."',
                    HTTP_HOST = '".mysql_escape_string($_SERVER["HTTP_HOST"])."',
                    HTTP_USER_AGENT = '".mysql_escape_string($_SERVER["HTTP_USER_AGENT"])."',
                    REQUEST_URI = '".mysql_escape_string($_SERVER["REQUEST_URI"])."',
                    REQUEST_METHOD = '".mysql_escape_string($_SERVER["REQUEST_METHOD"])."',
                    Country = '$country',
                    Browser = NULL,
                    OS = NULL,
                    Cookie_ID = '$CookieID',
                    Catalogue_ID = '$catalogue',
                    Subdivision_ID = '$sub',
                    Sub_Class_ID = '$cc',
                    Message_ID = '$message',
                    Action = '$action'
               ");

   Stats_UpdateSearchPhrases();
//   Stats_UpdateGeo();
}


function Stats_UpdateSearchPhrases()
{
    global $db, $HTTP_REFERER, $catalogue;

    $search_domains = array(0=>'www.yandex.ru', 'pda.yandex.ru', 'large.yandex.ru',
    'family.yandex.ru', 'www.rambler.ru', 'search.rambler.ru', 'sm.aport.ru',
    'go.mail.ru', 'search.msn.com', 'search.yahoo.com', 'www.altavista.com',
    'www.google.ru', 'www.google.com', 'www.alltheweb.com', 'yandex.ru');

    $search_queries = array(0=>'text', 'query', 'query', 'text', 'words', 'words',
    'r', 'q', 'q', 'p', 'q', 'q', 'q', 'q', 'text');

    $url = parse_url($HTTP_REFERER);
    if (!isset($url['host']) || !isset($url['query']))
    {
        return;
    }

    if (count($search_domains) != count($search_queries))
    {
        return;
    }

    for ($i=0; $i<count($search_domains); $i++)
    {
        $domain = $search_domains[$i];
        $query = $search_queries[$i];

        if ($domain == $url['host'])
        {
            $args = array();
            parse_str($url['query'], $args);

            if (isset($args[$query]) && strlen($args[$query]) > 0)
            {
                $now_date = date("Y-m-d");
                $search_phrase = urldecode($args[$query]);
                if ($i==13) // For AllTheWeb
                {
                    $search_phrase = html_entity_decode($search_phrase, ENT_QUOTES, "cp1251");
                }
                if ($i==11 || $i==12 || $i==10 || $i==8 || $i==9) // For Google, Altavista, MSN, Yahoo UTF-8
                {
                    //$search_phrase = iconv("UTF-8", "cp1251", $search_phrase);
                    //$search_phrase = stats_EncodeUTF($search_phrase, "w");
                    require_once("utf8/utf8.php");
                    $search_phrase = nc_utf2win($search_phrase);
                }
                $search_phrase = $db->escape($search_phrase);

                $q = $db->query("SELECT Hits FROM Stats_Phrases WHERE Date='$now_date' AND Phrase='$search_phrase' AND Catalogue_ID='$catalogue'");
                if ($db->num_rows == 0)
                {
                    // Insert new record
                    $db->query("INSERT INTO Stats_Phrases (Date, Phrase, Hits, Catalogue_ID) VALUES('$now_date', '$search_phrase', '1', '$catalogue')");
                }
                else
                {
                    // Update old record
                    $db->query("UPDATE Stats_Phrases SET Hits=Hits+1 WHERE Date='$now_date' AND Phrase='$search_phrase' AND Catalogue_ID='$catalogue'");
                }
            }
        }
    }
}

function Stats_IP2Country($ip)
{
    global $db;

    $ip = $_SERVER['REMOTE_ADDR'];
    $ip_long = floatval(sprintf("%u", ip2long($ip)));

    // Exclude LAN address

    if (( 167772160 < $ip_long  &&  $ip_long <  184549375) ||
        (2886729728 < $ip_long  &&  $ip_long < 2887778303) ||
        (3232235520 < $ip_long  &&  $ip_long < 3232301055))
            { return ''; }

    $nets = explode(".", $ip);

    $country = $db->get_var("SELECT Country
                               FROM Stats_IP2Country
                              WHERE IP_Net=$nets[0]
                                AND $ip_long BETWEEN IP_Range_Start
                                                 AND IP_Range_End");

    return $country;
}


//////////////////////////////////////////////////////////////////////////////
/**
  * @param string User Agent
  * @return bool whether user agent is bot
  */
function nc_stat_detect_bot($ua)
{
   $ua_lower = strtolower($ua);
   $bots = array('bot','crawler','yandex','webalta','stackrambler','aport','lupa.ru',
                 /*'googlebot',*/ 'mediapartners-google',
                 /*'yahoo-verticalcrawler',*/ 'yahoo! slurp','yahoo-mm','inktomi',
                 'slurp',/*'fast-webcrawler','msnbot',*/ 'ask jeeves','teoma',
                 'scooter',/*'openbot',*/ 'ia_archiver','zyborg','almaden',
                 'baiduspider',/*'psbot','gigabot','naverbot','surveybot',*/
                 'boitho.com-dc','objectssearch','answerbus','sohu-search',
                 'iltrovatore-setaccio','w3c_validator','wdg_validator',
                 'libwww-perl','jakarta commons-httpclient','python-urllib',
                 'getright','wget', 'reader');

   foreach ($bots as $bot)
   {
      if (strpos($ua_lower, $bot) !== FALSE) { return true; }
   }

   return false;
}


?>