<?php
/* $Id: mail.inc.php,v 1.12 2006/09/14 18:24:12 kx Exp $ */

/**
 * Quoted-printable header encoder (splited into 76-char chunks)
 *
 * @param string $input
 * @param string $charset
 * @return string
 */
function nc_quoted_printable_encode_header($input, $charset = MAIN_EMAIL_ENCODING)
{
   $str = preg_replace("/([^\x09\x21-\x3C\x3E-\x7E])/e",
                       '"=".strtoupper(dechex(ord("$1")))',
                       rtrim($input));

   // add encoding to the beginning of each line
   $encoding = "=?$charset?Q?";
   $content_length = 72 - strlen($encoding);

   preg_match_all("/.{1,$content_length}([^=]{0,2})?/", $str, $regs);
   $str = $encoding . join("?=\r\n\t$encoding", $regs[0]) . "?=";

   return $str;
}

/**
 * Quoted-printable string encoder
 *
 * @param unknown_type $input
 * @return unknown
 */
function nc_quoted_printable_encode($input)
{
   $tohex = '"=".strtoupper(dechex(ord("$1")))';
   $str = preg_replace('/([^\x09\x20\x0D\x0A\x21-\x3C\x3E-\x7E])/e', $tohex, $input);

   // encode x20, x09 at the end of lines
   $str = preg_replace("/([\x20\x09])(\r?\n)/e", $tohex.'$2', $str);

   // split into chunks
   $lines = explode("\n", $str);
   foreach ($lines as $num=>$line)
   {
      if (strlen($line) > 76)
      {
         preg_match_all('/.{1,73}([^=]{0,2})?/', $line, $regs);
         $lines[$num] = join("=\r\n", $regs[0]);
      }
   }
   $str = join("\n", $lines);

   return $str;
}
// ----------------------

function my_chunk_split($str)
{
        $stmp = base64_encode($str);
        $len = strlen($stmp);
        $out =  "";
    $done=0;
    while( $done<$len ) {
      $out.=( $len-$done>76)?substr($strp,$done, 76). "\r\n":substr($strp,$done, $len-$done). "\r\n";
      $done+=76;

    }
        return $out;
}


class CMIMEMail {
 var $to;
 var $reply;
 var $boundary =  "----=_NextPart_000_0009_01BF95E9.CDFD2060";
 var $smtp_headers;
 var $filename_real;
 var $body_plain;
 var $body_html;
 var $atcmnt;
 var $atcmnt_type;
 var $original_name;
 var $from_name;

 function CMIMEMail($priority=3) {
   $this->priority=$priority;
 }

 function mailbody( $plain, $html= "" ) {
   $this->body_plain=$plain;
   $this->body_html=$html;
 }

 function attach ($name, $original_name, $content_type, $data) {
   $this->atcmnt[$name]=$data;
   $this->atcmnt_type[$name]=$content_type;
   $this->original_name[$name]=$original_name;
 }

 function  attachFile ($fname, $original_name, $content_type) {
   $name = $fname;
   $f=fopen($name, "r");
   $size = filesize($name);
   $contents = fread ($f,$size);

   $this->attach($name, $original_name, $content_type, $contents);
   fclose($f);
 }

 function  clear() {
   unset( $atcmnt );
   unset( $atcmnt_type );
 }

 function  makeheader() {
   $out = "From: ".nc_quoted_printable_encode_header($this->from_name)." <".$this->from.">\n";
   $out .= "Reply-To: <".$this->reply.">\n";
   $out .= "Return-Path: <".$this->reply.">\n";
   $out .= "X-Mailer: PHP/" . phpversion()."\n";
   $out .= "MIME-Version: 1.0\nContent-Type: multipart/mixed;\n boundary=\"".$this->boundary. "\"\nX-Priority: ".$this->priority. "\n";
   return $out;
 }
 function  makebody() {
   global $SOURCE_CHARSET;
   $boundary2=  "----=_NextPart_001_0009_01BF95E9.CDFD2060";
   $out= "";
//   $out= "\n\n".$this->body_plain. "\n\n";
   if( $this->body_html!= "" ) {
     $out.= "--".$this->boundary. "\nContent-Type: multipart/alternative;\n boundary=$boundary2\n\n";
     $out.= "$body_plan\n--$boundary2\nContent-Type: text/plain\nContent-Transfer-Encoding: quoted-printable\n\n".$this->body_plain. "\n\n--$boundary2\nContent-Type: text/html\n".
            "Content-Transfer-Encoding: quoted-printable\n\n".
              nc_quoted_printable_encode($this->body_html).
             "\n\n--$boundary2--\n";
   } else {
     $out.= "--".$this->boundary. "\nContent-type: text/plain;charset=\"".MAIN_EMAIL_ENCODING."\"\nContent-Transfer-Encoding: quoted-printable\n\n".
              nc_quoted_printable_encode($this->body_plain).
            "\n";

   }
   @reset( $this->atcmnt_type);
   while( list($name, $content_type) = @each($this->atcmnt_type) ) {
     $out.= "\n--".$this->boundary. "\nContent-Type: $content_type\nContent-Transfer-Encoding: base64\nContent-Disposition: attachment; filename=\"".$this->original_name[$name]."\"\n\n".
       chunk_split(base64_encode($this->atcmnt[$name])). "\n";

   }
   $out.= "--".$this->boundary. "--\n";
   return $out;
 }

 function  send ($to, $from, $reply, $subject, $from_name) {
   $this->to=$to; $this->from=$from; $this->subject=$subject; $this->reply=$reply;
   $this->from_name=$from_name;
   mail( $this->to, nc_quoted_printable_encode_header($this->subject), $this->makebody(), $this->makeheader() );
 }
}


/**
 *    
 *
 * @param string $recipient
 * @param string $from
 * @param string $subject
 * @param string $message
 * @param string HTML-
 *
 *      HTML,    html_message.
 *    message     plain text    
 *
 *   plain text,  html_message   .
 */

function nc_mail2queue($recipient, $from, $subject, $message, $html_message="")
{
   require_once("Mail/Queue.php");

   $db_options = array('type' => 'ezsql', 'mail_table' => 'Mail_Queue');
   $mail_options = array('driver'=>'smtp');

   $mail_queue = new Mail_Queue($db_options, $mail_options);

   $hdrs = array('From' => $from,     // email only (no name!)
                 'To' => $recipient,  //    --- " ---
                 'Subject' => nc_quoted_printable_encode_header($subject));

   $mime =& new Mail_mime();
   if ($message)      $mime->setTXTBody($message);
   if ($html_message) $mime->setHTMLBody($html_message);
   $body = $mime->get(array('text_encoding'=>'8bit', 'html_charset'=>MAIN_EMAIL_ENCODING,
       'text_charset'=>MAIN_EMAIL_ENCODING, 'head_charset'=>MAIN_EMAIL_ENCODING));
   $hdrs = $mime->headers($hdrs);

   $mail_queue->put($from, $recipient, $hdrs, $body);
}

?>